using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;

namespace RobotinoMRDS.Examples.DriveCircle
{
    /// <summary>
    /// DriveCircle contract class
    /// </summary>
    public sealed class Contract
    {
        /// <summary>
        /// DSS contract identifer for DriveCircle
        /// </summary>
        [DataMember]
        public const string Identifier = "http://servicerobotics.eu/2011/11/drivecircle.html";
    }

    /// <summary>
    /// DriveCircle state
    /// </summary>
    [DataContract]
    public class DriveCircleState
    {
    }

    /// <summary>
    /// DriveCircle main operations port
    /// </summary>
    [ServicePort]
    public class DriveCircleOperations : PortSet<DsspDefaultLookup, DsspDefaultDrop, Get>
    {
    }

    /// <summary>
    /// DriveCircle get operation
    /// </summary>
    public class Get : Get<GetRequestType, PortSet<DriveCircleState, Fault>>
    {
    }
}


