using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;

namespace RobotinoMRDS.Examples.WallFollow
{
    /// <summary>
    /// WallFollow contract class
    /// </summary>
    public sealed class Contract
    {
        /// <summary>
        /// DSS contract identifer for WallFollow
        /// </summary>
        [DataMember]
        public const string Identifier = "http://servicerobotics.eu/2011/11/wallfollow.html";
    }

    /// <summary>
    /// WallFollow state
    /// </summary>
    [DataContract]
    public class WallFollowState
    {
    }

    /// <summary>
    /// WallFollow main operations port
    /// </summary>
    [ServicePort]
    public class WallFollowOperations : PortSet<DsspDefaultLookup, DsspDefaultDrop, Get>
    {
    }

    /// <summary>
    /// WallFollow get operation
    /// </summary>
    public class Get : Get<GetRequestType, PortSet<WallFollowState, Fault>>
    {
        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        public Get()
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        public Get(GetRequestType body)
            : base(body)
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        /// <param name="responsePort">the response port for the request</param>
        public Get(GetRequestType body, PortSet<WallFollowState, Fault> responsePort)
            : base(body, responsePort)
        {
        }
    }
}


