﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;

using robotino = rec.robotino.api2;

namespace RobotinoMRDS.Services.Robotino
{
    /// <summary>
    /// Robotino state
    /// </summary>
    [DataContract]
    public class RobotinoState
    {
        private bool _connected = false;
        private Bumper _bumper = new Bumper();
        private DistanceSensors _distanceSensors = new DistanceSensors();

        // Default constructor
        public RobotinoState()
        {
        }

        [DataMember]
        public bool Connected
        {
            get { return _connected; }
            set { _connected = value; }
        }

        [DataMember]
        public Bumper Bumper
        {
            get { return _bumper; }
            set { _bumper = value; }
        }

        [DataMember]
        public DistanceSensors DistanceSensors
        {
            get { return _distanceSensors;  }
            set { _distanceSensors = value; }
        }

    }

    [DataContract]
    public class Bumper
    {
        private bool _value = new bool();

        // Default constructor
        public Bumper()
        {
        }

        [DataMember]
        public bool Value
        {
            get { return _value; }
            set { _value = value; }
        }
    }

    [DataContract]
    public class DistanceSensors
    {
        private float[] _distances = new float[] {0f, 0f, 0f, 0f, 0f, 0f, 0f, 0f, 0f};

        // Default constructor
        public DistanceSensors()
        {
        }

        [DataMember]
        public float[] Distances
        {
            get { return _distances; }
            set { _distances = value; }
        }
    }
}
