using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;

namespace RobotinoMRDS.Simulation.Robotino
{
    /// <summary>
    /// Robotino contract class
    /// </summary>
    public sealed class Contract
    {
        /// <summary>
        /// DSS contract identifer for Robotino
        /// </summary>
        [DataMember]
        public const string Identifier = "http://servicerobotics.eu/2011/11/robotinotest.html";
    }

    /// <summary>
    /// Robotino state
    /// </summary>
    [DataContract]
    public class RobotinoTestState
    {
    }

    /// <summary>
    /// Robotino main operations port
    /// </summary>
    [ServicePort]
    public class RobotinoTestOperations : PortSet<DsspDefaultLookup, DsspDefaultDrop>
    {
    }
}