﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;

#region Simulation namespaces
using Microsoft.Robotics.Simulation;
using Microsoft.Robotics.Simulation.Engine;
using Microsoft.Robotics.Simulation.Physics;
using Microsoft.Robotics.PhysicalModel;
using xna = Microsoft.Xna.Framework;
#endregion

namespace RobotinoMRDS.Simulation.Robotino
{
    [DataContract]
    public class RobotinoWheel0Entity : WheelEntity
    {
        const float rotationScale = (float)(-1.0 / (2.0 * Math.PI));

        public RobotinoWheel0Entity()
        {
        }

        public RobotinoWheel0Entity(WheelShapeProperties wheelShape)
            : base(wheelShape)
        {
        }

        public override void Initialize(Microsoft.Xna.Framework.Graphics.GraphicsDevice device, PhysicsEngine physicsEngine)
        {
            base.Initialize(device, physicsEngine);
        }

        public override void Render(VisualEntity.RenderMode renderMode, MatrixTransforms transforms, CameraEntity currentCamera)
        {
            Wheel.State.LocalPose.Orientation = TypeConversion.FromXNA(
                xna.Quaternion.CreateFromAxisAngle(
                new xna.Vector3(-0.86602540378f, 0, -0.5f), (float)(Rotations * 2 * Math.PI)));
            base.Render(renderMode, transforms, currentCamera);
        }
    }

    [DataContract]
    public class RobotinoWheel1Entity : WheelEntity
    {
        const float rotationScale = (float)(-1.0 / (2.0 * Math.PI));

        public RobotinoWheel1Entity()
        {
        }

        public RobotinoWheel1Entity(WheelShapeProperties wheelShape)
            : base(wheelShape)
        {
        }

        public override void Initialize(Microsoft.Xna.Framework.Graphics.GraphicsDevice device, PhysicsEngine physicsEngine)
        {
            base.Initialize(device, physicsEngine);
        }

        public override void Render(VisualEntity.RenderMode renderMode, MatrixTransforms transforms, CameraEntity currentCamera)
        {
            Wheel.State.LocalPose.Orientation = TypeConversion.FromXNA(
                xna.Quaternion.CreateFromAxisAngle(
                new xna.Vector3(0, 0, -1), (float)(Rotations * 2 * Math.PI)));
            base.Render(renderMode, transforms, currentCamera);
        }
    }

    [DataContract]
    public class RobotinoWheel2Entity : WheelEntity
    {
        const float rotationScale = (float)(-1.0 / (2.0 * Math.PI));

        public RobotinoWheel2Entity()
        {
        }

        public RobotinoWheel2Entity(WheelShapeProperties wheelShape)
            : base(wheelShape)
        {
        }

        public override void Initialize(Microsoft.Xna.Framework.Graphics.GraphicsDevice device, PhysicsEngine physicsEngine)
        {
            base.Initialize(device, physicsEngine);
        }

        public override void Render(VisualEntity.RenderMode renderMode, MatrixTransforms transforms, CameraEntity currentCamera)
        {
            Wheel.State.LocalPose.Orientation = TypeConversion.FromXNA(
                xna.Quaternion.CreateFromAxisAngle(
                new xna.Vector3(0.86602540378f, 0, -0.5f), (float)(Rotations * 2 * Math.PI)));

            base.Render(renderMode, transforms, currentCamera);
        }
    }
}
