using System;
using System.Collections.Generic;
using System.ComponentModel;
using Microsoft.Ccr.Core;
using Microsoft.Dss.Core.Attributes;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.ServiceModel.DsspServiceBase;
using W3C.Soap;

namespace RobotinoMRDS.Simulation.Scenarios.WallFollow.SimWallFollow
{
    /// <summary>
    /// SimWallFollow contract class
    /// </summary>
    public sealed class Contract
    {
        /// <summary>
        /// DSS contract identifer for SimWallFollow
        /// </summary>
        [DataMember]
        public const string Identifier = "http://servicerobotics.eu/2011/11/simwallfollow.html";
    }

    /// <summary>
    /// SimWallFollow state
    /// </summary>
    [DataContract]
    public class SimWallFollowState
    {
    }

    /// <summary>
    /// SimWallFollow main operations port
    /// </summary>
    [ServicePort]
    public class SimWallFollowOperations : PortSet<DsspDefaultLookup, DsspDefaultDrop, Get>
    {
    }

    /// <summary>
    /// SimWallFollow get operation
    /// </summary>
    public class Get : Get<GetRequestType, PortSet<SimWallFollowState, Fault>>
    {
        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        public Get()
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        public Get(GetRequestType body)
            : base(body)
        {
        }

        /// <summary>
        /// Creates a new instance of Get
        /// </summary>
        /// <param name="body">the request message body</param>
        /// <param name="responsePort">the response port for the request</param>
        public Get(GetRequestType body, PortSet<SimWallFollowState, Fault> responsePort)
            : base(body, responsePort)
        {
        }
    }
}


